<template>
  <!-- BLOCKLY -->
  <!-- BLOCKLY BASADO EN RESPONDER A EVENTOS -->
  <!-- <BlocklyComponent id="blocklyMain" -->
  <!-- :options="options" :parentWorkspace="workspace" @add="loadBlocklyWorkspace" -->
  <!-- ref="blocklyMain"> -->

  <!-- MENU -->
  <!-- MENU BASADO REQUIERE SER TERMINADO -->
  <!-- <MenuComponent id="menu" :parentWorkspace="workspaceRef"></MenuComponent> -->

  <!-- MENU PRINCIPAL, ESTÁ ES LA BARRA DE TAREAS -->
  <FocusMenu id="mainMenu" :parentWorkspace="workspaceRef"></FocusMenu>

  <!-- SELECT EDITOR -->
  <EditorModeComponent
    id="editorMode"
    @fromParentSelectBlocklyOrCodeMirrorToShow="selectBlocklyOrCodeMirrorToShow"
    :fromParentVarEditorSelected="editorSelected"
  ></EditorModeComponent>

  <div id="editorSpace">
    <!-- BLOCKLY EDITOR -->
    <BlocklyComponent
      v-show="editorSelected == Editor.Blockly"
      id="blocklyMain"
      :options="options"
      @loadRefWorkspaceBlockly="loadRefWorkspaceBlockly"
      ref="blocklyMain"
    ></BlocklyComponent>
    <!-- CODEMIRRO EDITOR -->
    <CodeMirrorComponent
      v-show="editorSelected == Editor.Codemirror"
    ></CodeMirrorComponent>
  </div>

  <!-- FLOAT MENU -->
  <!-- Menu de opciones y acceso a otras funciones -->
  <FloatingCircularMenu
    id="menu2"
    :parentWorkspace="workspaceRef"
    @parentSendPreviewCode2Modal="sendPreviewCode2Modal"
    @parentSendConnectModal="sendConnectModal"
  ></FloatingCircularMenu>

  <!-- POPUP -->
  <!-- <SimplePopup id="popup1"></SimplePopup> -->

  <!-- MODAL POPUP -->
  <!-- <div id="modals"></div> -->
  <PreviewCodeModal
    :parentMessage="previewCode2ModalMsg"
    :trigger="triggerPreviewCodeModal"
  ></PreviewCodeModal>

  <ConnectModal
    :parentMessage="connectModalMsg"
    :trigger="triggerConnectModal"
  ></ConnectModal>
</template>

<script lang="ts">
/**
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @fileoverview Main Vue component that includes the Blockly component.
 * @author Johnny Cubides <jgcubidesc@gmail.com>
 */

// import { Component, Vue } from 'vue-property-decorator'
import { defineComponent, ref, onMounted } from "vue";
// -- IMPORT COMPONENTS --
import FocusMenu from "./components/FocusMenu.vue";
import EditorModeComponent from "./components/EditorModeComponent.vue";
import BlocklyComponent from "./components/BlocklyComponent.vue";
import CodeMirrorComponent from "./components/CodeMirrorComponent.vue";
// import MenuComponent from './components/MenuComponent.vue'
// import FloatMenuComponent from './components/FloatMenuComponent.vue'
import FloatingCircularMenu from "./components/FloatingCircularMenu.vue";

// -- IMPORT MODALS COMPONENTS --
import PreviewCodeModal from "./components/modals/PreviewCodeModal.vue";
import ConnectModal from "./components/modals/ConnectModal.vue";

// -- BLOCKLY LIBS --
import Blockly from "@johnnycubides/blockly-catalejo/";
import DarkTheme from "@blockly/theme-dark";
// -- BLOCKLY TOOLBOX --
//import { toolbox } from "./blockly-config/example/toolbox-example"; // Ejemplo
//import { toolbox } from "./blockly-config/example/toolbox-simple-xml.js";
import { toolbox } from "./blockly-config/luabot/toolbox";

// -- BLOCKLY LANGUAGE GENERATOR --
//import "./blockly-config/luabot/luabot";

// import './blocks/stocks'
// import './prompt'

const App = defineComponent({
  name: "app",
  components: {
    FocusMenu,
    BlocklyComponent,
    CodeMirrorComponent,
    EditorModeComponent,
    // MenuComponent,
    // FloatMenuComponent,
    FloatingCircularMenu,
    // -- START MODALS COMPONENTS START --
    PreviewCodeModal,
    ConnectModal,
  },
  // tslint:disable-next-line
  setup (_, context) { // eslint-disable-line
    const code = ref(null);
    const workspaceRef = ref(new Blockly.Workspace());
    const options = ref({});

    // -- Select editor --
    enum Editor {
      Codemirror = 0,
      Blockly = 1,
    }
    const editorSelected = ref(Editor.Blockly);

    // -- MODALS VARS MSG --
    const previewCode2ModalMsg = ref("");
    const connectModalMsg = ref("");
    // -- MODALS TRIGGERS --
    const triggerPreviewCodeModal = ref(false);
    const triggerConnectModal = ref(false);

    // https://developers.google.com/blockly/guides/configure/web/configuration_struct
    options.value = {
      media: "media/",
      theme: DarkTheme, // DarkTheme funciona con blockly 9.0 en adelante
      renderer: "geras", // geras, thrasos, zelos
      toolboxPosition: "start", // [toolboxPosition, horizontalLayout] top: [start, true], bottom:end-true, left: [start, false], right:[end, false]
      horizontalLayout: false,
      zoom: {
        controls: true,
        wheel: true,
        startScale: 1.0,
        maxScale: 3,
        minScale: 0.3,
        scaleSpeed: 1.2,
        pinch: true,
      },
      trashcan: true,
      grid: {
        spacing: 25,
        length: 1,
        colour: "#ccc",
        snap: true,
      },
      toolbox: toolbox,
    };

    // Esta referencia construye el workspace que será usado en
    // los componentes hijos de la aplicación
    // Emit for child
    const loadRefWorkspaceBlockly = (workspaceToRef) => {
      workspaceRef.value = workspaceToRef;
    };

    // Emit for child
    const sendPreviewCode2Modal = (message) => {
      previewCode2ModalMsg.value = message;
      triggerPreviewCodeModal.value = !triggerPreviewCodeModal.value; // trigger the modal
    };

    // Emit for child
    const sendConnectModal = (message) => {
      connectModalMsg.value = message;
      triggerConnectModal.value = !triggerConnectModal.value; // trigger the modal
    };

    const selectBlocklyOrCodeMirrorToShow = () => {
      if (editorSelected.value == Editor.Blockly) {
        editorSelected.value = Editor.Codemirror;
      } else {
        editorSelected.value = Editor.Blockly;
      }
    };

    return {
      // --VARS --
      Editor, // Editor.[Blockly, Codemirror]
      // blockly vars start
      code,
      workspaceRef, // general ref of blockly workspace
      options, // options blockly
      // blockly vars end

      editorSelected,
      // -- METHODS --
      // -- MODALS VARS MSG --
      previewCode2ModalMsg,
      connectModalMsg,
      // -- MODALS TRIGGERS --
      triggerPreviewCodeModal,
      triggerConnectModal,
      // -- METHODS FOR EMITS --
      selectBlocklyOrCodeMirrorToShow,
      loadRefWorkspaceBlockly,
      sendPreviewCode2Modal,
      sendConnectModal,
    };
  },
});

export default App;
</script>

<style>
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  color: #2c3e50;
  display: flex;
  flex-direction: column;
  margin: 0;
}

html,
body {
  margin: 0;
}

/*
#code {
  position: absolute;
  right: 0;
  bottom: 0;
  width: 40%;
  height: 50%;
  margin: 0;
  background-color: beige;
}
*/
/*
#blockly1 {
  position: absolute;
  right: 0;
  top: 0;
  width: 50%;
  height: 50%;
}*/

#mainMenu {
  /*position: absolute;*/
  /*top: 0px;*/
  height: 60px; /* 72px */
  width: 100%;
}

#blocklyMain {
  /* top: 60px; /* 60px, 72px */
  /* position: relative; /* relative, absolute */
  /*left: 0;*/
  /*bottom: 0;*/
  /*width: 100%;*/
  /*height: 90%;*/
}


#modals {
}
</style>
